#include "draw.h"

void drawCube(BUF *buffer,double *vertices,int *pos,int *faces,int *colors)
{
  int i=0,j=0;
  int a=0,b=0,c=0,d=0;
  double e=0.0,f=0.0,g=0.0;
  double dist[6]={0.0};
  
  for(i=0;i<6;i++)
  {
    e=vertices[faces[i*4]*3-3]/2.0+vertices[faces[i*4+2]*3-3]/2.0;
    f=vertices[faces[i*4]*3-2]/2.0+vertices[faces[i*4+2]*3-2]/2.0;
    g=vertices[faces[i*4]*3-1]/2.0+vertices[faces[i*4+2]*3-1]/2.0;
    dist[i]=e*e+(f+10.0)*(f+10.0)+g*g;
  }
  
  for(i=0;i<5;i++)
  {
    for(j=0;j<5-i;j++)
    {
      if(dist[j]>dist[j+1])
      {
        e=dist[j];
        dist[j]=dist[j+1];
        dist[j+1]=e;
        invertTableElems(faces,4*j,4*j+4);
        invertTableElems(faces,4*j+1,4*j+5);
        invertTableElems(faces,4*j+2,4*j+6);
        invertTableElems(faces,4*j+3,4*j+7);
        invertTableElems(colors,j,j+1);
      }
    }
  }
  
  i=2;
  while(i>=0)
  {
    a=faces[i*4]-1;
    b=faces[i*4+1]-1;
    c=faces[i*4+2]-1;
    d=faces[i*4+3]-1;
    drawTriangle(buffer,colors[i],pos[a*2],pos[a*2+1],pos[b*2],pos[b*2+1],pos[c*2],pos[c*2+1]);
    drawTriangle(buffer,colors[i],pos[d*2],pos[d*2+1],pos[a*2],pos[a*2+1],pos[c*2],pos[c*2+1]);
    i--;
  }
}

void drawTriangle(BUF *buffer,int color,int x1,int y1,int x2,int y2,int x3,int y3)
{
  int i=0;
  if(y1>y2)
  {
    invertVars(&y1,&y2);
    invertVars(&x1,&x2);
  }
  if(y1>y3)
  {
    invertVars(&y1,&y3);
    invertVars(&x1,&x3);
  }
  if(y2>y3)
  {
    invertVars(&y2,&y3);
    invertVars(&x2,&x3);
  }
  for(i=1;i<=y2-y1;i++)
  {
    bufHorizLine(buffer,x1+(x2-x1)*i/(y2-y1),y1+i,x1+(x3-x1)*i/(y3-y1),color);
  }
  for(i=1;i<=y3-y2;i++)
  {
    bufHorizLine(buffer,x2+(x3-x2)*i/(y3-y2),y2+i,x1+(x3-x1)*(y2-y1+i)/(y3-y1),color);
  }
}

