#include "buffer.h"
#include "draw.h"
#include "3D.h"

int main(void)
{
  BUF *buffer=malloc(SCR_SIZE);

  double points[8*3]={1.0,1.0,1.0,  1.0,1.0,-1.0,  1.0,-1.0,1.0,  1.0,-1.0,-1.0,  -1.0,1.0,1.0,  -1.0,1.0,-1.0,  -1.0,-1.0,1.0,  -1.0,-1.0,-1.0};
  int faces[6*4]={1,2,4,3,  1,5,6,2,  1,3,7,5,  8,7,3,4,  8,7,5,6,  8,4,2,6};
  int colors[6]={0,2,4,6,8,10};
  double i=0;

  double *pointsimg=malloc(sizeof(points));
  double angleX=0.0,angleZ=0.0;
  int* pos=malloc(8*2*sizeof(int));
  while(!isKeyPressed(KEY_NSPIRE_ESC))
  {
    if(isKeyPressed(KEY_NSPIRE_UP))
      angleX+=1.0;
    if(isKeyPressed(KEY_NSPIRE_DOWN))
      angleX-=1.0;
    if(isKeyPressed(KEY_NSPIRE_RIGHT))
      angleZ+=1.0;
    if(isKeyPressed(KEY_NSPIRE_LEFT))
      angleZ-=1.0;
    bufFill(buffer,0xFF);

    memcpy(pointsimg,points,sizeof(points));
    rotateZ(pointsimg,8,angleZ);
    rotateX(pointsimg,8,angleX);
    translate(pointsimg,8,-10.0,30.0,-5.0);
    for(i=0.0;i<10.0;i+=1.0)
    {
      translate(pointsimg,8,2.0,0.0,1.0);
      computeVertices(pointsimg,pos,8);
      drawCube(buffer,pointsimg,pos,faces,colors);
    }

    bufDisplay(buffer);
  }

  free(pointsimg);
  free(pos);
  free(buffer);
  return 0;
}

